from paida.paida_core.PAbsorber import *
from types import SliceType, TupleType
from os import linesep

class array2:
	def __init__(self, data, indices = None, _in = False, _1ds = None):
		if _in:
			self.data = data
			self.indices = indices
			self._1ds = _1ds
		else:
			dimI = len(data)
			dimJ = len(data[0])
			if indices == None:
				self.indices = [range(dimI), range(dimJ)]
			else:
				self.indices = indices
			self._1ds = [False, False]
			data2 = []
			for i in self.indices[0]:
				temp = []
				for j in self.indices[1]:
					temp.append(data[i][j])
				data2.append(temp)
			self.data = data2

	def __str__(self):
		if self._1ds[0]:
			iData = self.data[self.indices[0][0]]
			result = '['
			for j in self.indices[1]:
				result += `iData[j]` + ', '
			result = result[:-2] + ']'
		elif self._1ds[1]:
			j = self.indices[1][0]
			data = self.data
			result = '['
			for i in self.indices[0]:
				result += `data[i][j]` + ', '
			result = result[:-2] + ']'
		else:
			data = self.data
			result = '[['
			for i in self.indices[0]:
				for j in self.indices[1]:
					result += `data[i][j]` + ', '
				result = result[:-2] + '],' + linesep + ' ['
			result = result[:-4] + ']'
		return result

	def toArray(self):
		if self._1ds[0]:
			iData = self.data[self.indices[0][0]]
			result = []
			for j in self.indices[1]:
				result.append(iData[j])
		elif self._1ds[1]:
			j = self.indices[1][0]
			data = self.data
			result = []
			for i in self.indices[0]:
				result.append(data[i][j])
		else:
			data = self.data
			result = []
			for i in self.indices[0]:
				result2 = []
				for j in self.indices[1]:
					result2.append(data[i][j])
				result.append(result2)
		return result

	def __getitem__(self, s):
		sType = type(s)
		if sType == SliceType:
			indicesI = self.indices[0]
			indicesJ = self.indices[1]
			if s.start == None:
				start = 0
			else:
				start = s.start
			if s.stop == None:
				stop = len(indicesI)
			else:
				stop = min(s.stop, len(indicesI))
			indices = []
			if self._1ds[0]:
				if s.step == None:
					for j in range(start, stop):
						indices.append(indicesJ[j])
				else:
					for j in range(start, stop, s.step):
						indices.append(indicesJ[j])
				return array2(self.data, [indicesI, indices], True, [True, False])
			elif self._1ds[1]:
				if s.step == None:
					for i in range(start, stop):
						indices.append(indicesI[i])
				else:
					for i in range(start, stop, s.step):
						indices.append(indicesI[i])
				return array2(self.data, [indices, indicesJ], True, [False, True])
			else:
				if s.step == None:
					for i in range(start, stop):
						indices.append(indicesI[i])
				else:
					for i in range(start, stop, s.step):
						indices.append(indicesI[i])
				return array2(self.data, [indices, indicesJ], True, [False, False])

		elif sType == TupleType:
			si, sj = s
			indicesI = self.indices[0]
			indicesJ = self.indices[1]

			if type(si) == SliceType:
				if si.start == None:
					startI = 0
				else:
					startI = si.start
				if si.stop == None:
					stopI= len(indicesI)
				else:
					stopI = min(si.stop, len(indicesI))
				indicesI2 = []
				if si.step == None:
					for i in range(startI, stopI):
						indicesI2.append(indicesI[i])
				else:
					for i in range(startI, stopI, si.step):
						indicesI2.append(indicesI[i])

				if type(sj) == SliceType:
					if sj.start == None:
						startJ = 0
					else:
						startJ = sj.start
					if sj.stop == None:
						stopJ = len(indicesJ)
					else:
						stopJ = min(sj.stop, len(indicesJ))
					indicesJ2 = []
					if sj.step == None:
						for j in range(startJ, stopJ):
							indicesJ2.append(indicesJ[j])
					else:
						for j in range(startJ, stopJ, sj.step):
							indicesJ2.append(indicesJ[j])

					return array2(self.data, [indicesI2, indicesJ2], True, [False, False])

				else:
					return array2(self.data, [indicesI2, [indicesJ[sj]]], True, [False, True])
			else:
				if type(sj) == SliceType:
					if sj.start == None:
						startJ = 0
					else:
						startJ = sj.start
					if sj.stop == None:
						stopJ = len(indicesJ)
					else:
						stopJ = min(sj.stop, len(indicesJ))
					indicesJ2 = []
					if sj.step == None:
						for j in range(startJ, stopJ):
							indicesJ2.append(indicesJ[j])
					else:
						for j in range(startJ, stopJ, sj.step):
							indicesJ2.append(indicesJ[j])
					
					return array2(self.data, [[indicesI[si]], indicesJ2], True, [True, False])

				else:
					return self.data[indicesI[si]][indicesJ[sj]]

		else:
			if self._1ds[0]:
				return self.data[self.indices[0][0]][self.indices[1][s]]
			elif self._1ds[1]:
				return self.data[self.indices[0][s]][self.indices[1][0]]
			else:
				return array2(self.data, [[self.indices[0][s]], self.indices[1]], True, [True, False])

	def __setitem__(self, s, v):
		sType = type(s)
		if sType == SliceType:
			indicesI = self.indices[0]
			indicesJ = self.indices[1]
			if s.start == None:
				start = 0
			else:
				start = s.start
			if s.stop == None:
				stop = len(indicesI)
			else:
				stop = min(s.stop, len(indicesI))
			indices = []
			if self._1ds[0]:
				i = indicesI[0]
				vi = 0
				if s.step == None:
					for j in range(start, stop):
						self.data[i][indicesJ[j]] = v[vi]
						vi += 1
				else:
					for j in range(start, stop, s.step):
						self.data[i][indicesJ[j]] = v[vi]
						vi += 1
			elif self._1ds[1]:
				j = indicesJ[0]
				vi = 0
				if s.step == None:
					for i in range(start, stop):
						self.data[indicesI[i]][j] = v[vi]
						vi += 1
				else:
					for i in range(start, stop, s.step):
						self.data[indicesI[i]][j] = v[vi]
						vi += 1
			else:
				vi = 0
				if s.step == None:
					for i in range(start, stop):
						vj = 0
						dataI = self.data[indicesI[i]]
						valI = v[vi]
						for j in indicesJ:
							dataI[j] = valI[vj]
							vj += 1
						vi += 1
				else:
					for i in range(start, stop, s.step):
						vj = 0
						dataI = self.data[indicesI[i]]
						valI = v[vi]
						for j in indicesJ:
							dataI[j] = valI[vj]
							vj += 1
						vi += 1

		elif sType == TupleType:
			si, sj = s
			indicesI = self.indices[0]
			indicesJ = self.indices[1]
			
			if type(si) == SliceType:
				if si.start == None:
					startI = 0
				else:
					startI = si.start
				if si.stop == None:
					stopI= len(indicesI)
				else:
					stopI = min(si.stop, len(indicesI))
				indicesI2 = []
				if si.step == None:
					for i in range(startI, stopI):
						indicesI2.append(indicesI[i])
				else:
					for i in range(startI, stopI, si.step):
						indicesI2.append(indicesI[i])

				if type(sj) == SliceType:
					if sj.start == None:
						startJ = 0
					else:
						startJ = sj.start
					if sj.stop == None:
						stopJ = len(indicesJ)
					else:
						stopJ = min(sj.stop, len(indicesJ))
					indicesJ2 = []
					if sj.step == None:
						for j in range(startJ, stopJ):
							indicesJ2.append(indicesJ[j])
					else:
						for j in range(startJ, stopJ, sj.step):
							indicesJ2.append(indicesJ[j])

					vi = 0
					for i in indicesI2:
						vj = 0
						dataI = self.data[i]
						valI = v[vi]
						for j in indicesJ2:
							dataI[j] = valI[vj]
							vj += 1
						vi += 1

				else:
					vi = 0
					j = indicesJ[sj]
					for i in indicesI2:
						self.data[i][j] = v[vi]
						vi += 1
			else:
				if type(sj) == SliceType:
					if sj.start == None:
						startJ = 0
					else:
						startJ = sj.start
					if sj.stop == None:
						stopJ = len(indicesJ)
					else:
						stopJ = min(sj.stop, len(indicesJ))
					indicesJ2 = []
					if sj.step == None:
						for j in range(startJ, stopJ):
							indicesJ2.append(indicesJ[j])
					else:
						for j in range(startJ, stopJ, sj.step):
							indicesJ2.append(indicesJ[j])

					vi = 0
					dataI = self.data[indicesI[si]]
					for j in indicesJ2:
						dataI[j] = v[vi]
						vi += 1

				else:
					self.data[indicesI[si]][indicesJ[sj]] = v

		else:
			if self._1ds[0]:
				self.data[self.indices[0][0]][self.indices[1][s]] = v
			elif self._1ds[1]:
				self.data[self.indices[0][s]][self.indices[1][0]] = v
			else:
				vi = 0
				dataI = self.data[self.indices[0][s]]
				for j in self.indices[1]:
					dataI[j] = v[vi]
					vi += 1
